// Program Code: Attiny44_Serial_Node_A
// Written by: Jorge Suarez de Freitas + Samuel Zegarra

#include <SoftwareSerial.h>

// Define the RX and TX pins
#define TX 9   // Transmit pin
#define RX 10  // Receive pin

// Define the LED pins
#define LED1 1
#define LED2 2
#define LED3 3

// Define the LM35 sensor pin
#define LM35 0

// Initialize SoftwareSerial with RX and TX pins
SoftwareSerial mySerial(RX, TX);

void setup() {
  // Initialize serial communications at 9600 bps
  mySerial.begin(9600);

  // Set initial pin modes
  pinMode(TX, INPUT); // Set TX as input to ensure it's tri-stated (high impedance)
  pinMode(LED1, OUTPUT);
  pinMode(LED2, OUTPUT);
  pinMode(LED3, OUTPUT);
  pinMode(LM35, INPUT);
}

void loop() {
  // Read a character from the serial port
  char chr = mySerial.read();

  // Check if the character is 'a'
  if (chr == 'a') {
    // Blink LEDs sequentially
    digitalWrite(LED1, HIGH);
    delay(500);
    digitalWrite(LED1, LOW);
    delay(500);
    digitalWrite(LED2, HIGH);
    delay(500);
    digitalWrite(LED2, LOW);
    delay(500);
    digitalWrite(LED3, HIGH);
    delay(500);
    digitalWrite(LED3, LOW);

    // Transmit the character back
    pinMode(TX, OUTPUT); // Set TX as output to transmit data
    mySerial.println(chr);
    delay(1000); // Ensure transmission is complete
    pinMode(TX, INPUT); // Set TX back to input (tri-state)
  }
  // Check if the character is 'T'
  else if (chr == 'T') {
    // Read and transmit temperature
    lm35();
  }
}

void lm35() {
  // Read temperature from LM35
  int tempReading = analogRead(LM35);
  float voltage = tempReading * (5.0 / 1023.0);  // Convert analog reading to voltage
  float temperature = voltage * 100;  // Convert voltage to temperature (10mV per degree Celsius)

  // Transmit the temperature reading
  pinMode(TX, OUTPUT); // Set TX as output to transmit data
  mySerial.print("Temperature: ");
  mySerial.print(temperature);
  mySerial.println(" C");
  delay(1000); // Ensure transmission is complete
  pinMode(TX, INPUT); // Set TX back to input (tri-state)
}
