// Program Code: Attiny44_Serial_Node_B
// Written by: Jorge Suarez de Freitas + Samuel Zegarra

#include <SoftwareSerial.h>

// Define the RX and TX pins
#define TX 9   // Transmit pin
#define RX 10  // Receive pin

// Define the LED pins
#define LED1 1
#define LED2 2
#define LED3 3

// Define the Button pin
#define Button 0

// Initialize SoftwareSerial with RX and TX pins
SoftwareSerial mySerial(RX, TX);

void setup() {
  // Initialize serial communications at 9600 bps
  mySerial.begin(9600);

  // Set initial pin modes
  pinMode(TX, INPUT); // Set TX as input to ensure it's tri-stated (high impedance)
  pinMode(LED1, OUTPUT);
  pinMode(LED2, OUTPUT);
  pinMode(LED3, OUTPUT);
  pinMode(Button, INPUT);
}

void loop() {
  // Read a character from the serial port
  char chr = mySerial.read();

  // Check if the character is 'b'
  if (chr == 'b') {
    // Blink LEDs sequentially
    digitalWrite(LED1, HIGH);
    delay(500);
    digitalWrite(LED1, LOW);
    delay(500);
    digitalWrite(LED2, HIGH);
    delay(500);
    digitalWrite(LED2, LOW);
    delay(500);
    digitalWrite(LED3, HIGH);
    delay(500);
    digitalWrite(LED3, LOW);

    // Transmit the character back
    pinMode(TX, OUTPUT); // Set TX as output to transmit data
    mySerial.println(chr);
    delay(1000); // Ensure transmission is complete
    pinMode(TX, INPUT); // Set TX back to input (tri-state)
  }
  // Check if the character is 'm'
  else if (chr == 'm') {
    // Check the button state and transmit it
    button(chr);
  }
}

void button(char chr) {
  // Ensure the received character is 'm'
  if (chr == 'm') {
    // Read the button state
    int state = digitalRead(Button);

    // Transmit the button state
    pinMode(TX, OUTPUT); // Set TX as output to transmit data
    mySerial.print("Button State: ");
    mySerial.println(state);
    delay(1000); // Ensure transmission is complete
    pinMode(TX, INPUT); // Set TX back to input (tri-state)
  }
}
